// JGetFTP.java
// Get Partial Content for FTP.

package JP.gr.java_conf.tech.jget;

import java.io.*;
import java.net.*;
import JP.gr.java_conf.tech.ftp.FTPClient;
import JP.gr.java_conf.tech.net.URLUtil;

/**
	FTPpARec̎擾

	@version	0.03 10/09/1999
	@author		Takahiro Shigemoto
*/
public class JGetFTP extends JGet
{
	// FTPڑNX
	FTPClient ftp_conn;

	// 擾ΏURL
	private URL url;

	// 擾P(byteTCY)
	private int block_size;

	// RecTCY
	private int content_length = 0;

	/**
		URLƃubNTCYƃ[U[ApX[hw肵āAFTPT[oɐڑ
		@param	url			ΏURL
		@param	block_size	擾P(byteTCY)
		@param	user_name	[U
		@param	password	pX[h
	*/
	public JGetFTP(URL url, int block_size, String user_name, String password)
	{
		this.url = url;

		// f[^`FbN
		if(user_name == null || password == null)
			throw new CannotGetError("Cannot Authenticate");

		if(block_size == 0)
			this.block_size = JGet.DEFAULT_BLOCK_SIZE;
		else
			this.block_size = block_size;

		// FTPRlNV̊m
		ftp_conn = new FTPClient(url.getHost(), user_name, password);

		// Ŝ̃RecTCY̎擾
		ftp_conn.changeDirectory(URLUtil.getPath(url));
		content_length = ftp_conn.getFileSize(URLUtil.getFileName(url));

		// T[ȏΉ/Ή̒
		String server_name = ftp_conn.getServerInfo();
		boolean b_available = ftp_conn.isCommandAvailable("REST");

		if(!b_available)
			throw new CannotGetError("Server(" + server_name +") is not Available");
		System.out.println("Server(" + server_name + ") is OK.");
	}

	/**
		RecŜ̃TCY̎擾
		@return	RecTCY
	*/
	public int getContentLength()
	{
		return(content_length);
	}

	/**
		Rec̎擾
		@param	buffer	]obt@
		@param	offset	擾Jnʒu
		@return	ǂݍ񂾃oCg
	*/
	public int getPartialContent(byte[] buffer, int offset)
	{
		// f[^̓ǂݍ
		ftp_conn.setOffset(offset);
		int read_length = ftp_conn.getBinaryFile(buffer, URLUtil.getFileName(url), block_size);

		return(read_length);
	}
}