// JGetHTTP.java
// Get Partial Content for HTTP.

package JP.gr.java_conf.tech.jget;

import java.io.*;
import java.net.*;
import JP.gr.java_conf.tech.net.Base64;

/**
	HTTPpARec̎擾

	@version	0.10 10/09/1999
	@author		Takahiro Shigemoto
*/
public class JGetHTTP extends JGet
{
	// 擾ΏURL
	private URL url;

	// 擾P(byteTCY)
	private int block_size;

	// User-Agent
	private String ua_string;

	// RecTCY
	private int content_length = 0;

	// Fؕ
	private String auth_string = null;

	/**
		URLƃubNTCYUser-AgentƔF؏w肵āAHTTPT[oɐڑ
		@param	url			ΏURL
		@param	block_size	擾P(byteTCY)
		@param	ua_string	User-Agent
		@param	user_name	[U
		@param	password	pX[h
	*/
	public JGetHTTP(URL url, int block_size, String ua_string, String user_name, String password)
	{
		this.url = url;

		// f[^`FbN
		if((user_name != null && password == null) || (user_name == null && password != null))
			throw new CannotGetError("Cannot Authenticate");

		if(block_size == 0)
			this.block_size = JGet.DEFAULT_BLOCK_SIZE;
		else
			this.block_size = block_size;

		if(ua_string == null)
			this.ua_string = JGet.UA_DEFAULT;
		else
			this.ua_string = ua_string;

		try
		{
			// HTTPRlNV̊m
			HttpURLConnection http_conn = (HttpURLConnection)url.openConnection();
			http_conn.setRequestProperty("Accept", "*/*");
			http_conn.setRequestProperty("User-Agent", this.ua_string);
			http_conn.setRequestProperty("Connection", "close");
			if(user_name != null && password != null)
			{
				auth_string = "Basic " + new String(Base64.encode(user_name + ":" + password));
				http_conn.setRequestProperty("Authorization", auth_string);
			}

			// T[oX|X̃`FbN
			int response_code = http_conn.getResponseCode();
			switch(response_code)
			{
				case 200: case 203:
					break;
				default:
					throw new CannotGetError(response_code + ": " + http_conn.getResponseMessage());
			}

			// Ŝ̃RecTCY̎擾
			content_length = http_conn.getContentLength();

			// T[ȏΉ/Ή̒
			String accept_ranges = http_conn.getHeaderField("Accept-Ranges");
			String server_name = http_conn.getHeaderField("Server");

			if(accept_ranges == null || !accept_ranges.equals("bytes"))
				throw new CannotGetError("Server(" + server_name +") is not Available");
			System.out.println("Server(" + server_name + ") is OK.");
		}
		catch(IOException io_ex)
		{
			io_ex.printStackTrace();
			throw new CannotGetError("IO_Exception");
		}
	}

	/**
		RecŜ̃TCY̎擾
		@return	RecTCY
	*/
	public int getContentLength()
	{
		return(content_length);
	}

	/**
		Rec̎擾
		@param	buffer	]obt@
		@param	offset	擾Jnʒu
		@return	ǂݍ񂾃oCg
	*/
	public int getPartialContent(byte[] buffer, int offset)
	{
		try
		{
			// HTTPRlNV̊m
			HttpURLConnection http_conn = (HttpURLConnection)url.openConnection();
			http_conn.setRequestProperty("Accept", "*/*");
			http_conn.setRequestProperty("User-Agent", ua_string);
			http_conn.setRequestProperty("Connection", "close");
			http_conn.setRequestProperty("Range", "bytes=" + offset + "-" + (offset + block_size - 1));
			if(auth_string != null)
				http_conn.setRequestProperty("Authorization", auth_string);

			// T[oX|X̃`FbN
			int response_code = http_conn.getResponseCode();
			switch(response_code)
			{
				case 202: case 408: case 503: case 504:
					// TimeOutȂǁA蒼\ꍇ
					return(-1);
				case 200: case 203: case 206:
					// ȏꍇ
					break;
				default:
					// 擾s\ȏꍇ
					throw new CannotGetError(response_code + ": Invalid Server Response");
			}

			// f[^̓ǂݍ
			BufferedInputStream input = new BufferedInputStream(http_conn.getInputStream());
			int current_content_length = http_conn.getContentLength();
			int read_length = input.read(buffer, offset, current_content_length);

			// ؒf
			input.close();
			http_conn.disconnect();

			return(read_length);
		}
		catch(IOException io_ex)
		{
			throw new CannotGetError("IO_Exception");
		}
	}
}