// JGetManager.java
// Information Manager for JGet

package JP.gr.java_conf.tech.jget;

import java.io.*;
import java.net.URL;
import java.util.Hashtable;
import JP.gr.java_conf.tech.net.URLUtil;

/**
	hLg̎擾ǗNX

	@version	0.09 10/09/1999
	@author		Takahiro Shigemoto
*/
public class JGetManager extends Thread
{
	// JGet̎擾
	private static final String info_list_file = "jget_info.lst";
	private static Hashtable jget_info_list;
	private JGetInfo jget_info;

	// Rec擾pIuWFNg
	private JGet jget;

	// vgR\킷
	/** HTTP\킷 */
	private static final String PROTOCOL_HTTP = "http";

	/** FTP\킷 */
	private static final String PROTOCOL_FTP = "ftp";

	/**
		URLƃubNTCYUser-AgentƔF؏w肵āARec擾
		@param	url			ΏURL
		@param	block_size	擾P(byteTCY)
		@param	ua_string	User-Agent
		@param	user_name	[U
		@param	password	pX[h
	*/
	public JGetManager(URL url, int block_size, String ua_string, String user_name, String password)
	{
		File info_file = new File(info_list_file);
		if(info_file.exists())
		{
			// 擾󋵃Xg̎擾
			if(jget_info_list == null)
				jget_info_list = loadInfoList();

			if(jget_info_list.containsKey(url))
			{
				// 擾󋵃XgɁAYURL݂ꍇ
				this.jget_info = (JGetInfo)jget_info_list.get(url);
				jget_info.setResume(true);
			}
			else
			{
				// 擾󋵃XgɁAYURLo^ĂȂꍇ
				this.jget_info = new JGetInfo(url, block_size, ua_string, 0, false);
				jget_info_list.put(url, jget_info);
			}
		}
		else
		{
			// ŃA擾󋵃t@CĂȂ
			if(jget_info_list == null)
				jget_info_list = new Hashtable();

			this.jget_info = new JGetInfo(url, block_size, ua_string, 0, false);
			jget_info_list.put(url, jget_info);
		}

		String protocol = jget_info.getURL().getProtocol();
		if(protocol.equals(JGetManager.PROTOCOL_HTTP))
			jget = new JGetHTTP(url, jget_info.getBlockSize(), jget_info.getUserAgentString(), user_name, password);
		else if(protocol.equals(JGetManager.PROTOCOL_FTP))
			jget = new JGetFTP(url, jget_info.getBlockSize(), user_name, password);
	}

	/**
		f[^擾
	*/
	public void run()
	{
		try
		{
			BufferedOutputStream output;
			if(jget_info.isResume())
				output = new BufferedOutputStream(new FileOutputStream(URLUtil.getFileName(jget_info.getURL()), true));
			else
				output = new BufferedOutputStream(new FileOutputStream(URLUtil.getFileName(jget_info.getURL())));

			// f[^i[pobt@̍\z
			int content_length = jget.getContentLength();
			byte[] buffer = new byte[content_length];

			// RecubNTCYÂ擾At@Cɏ
			System.out.println("Started : " + jget_info.getURL());

			int read_length = jget_info.getCurrentPosition();
			while(read_length < content_length)
			{
				int partial_content_length = jget.getPartialContent(buffer, read_length);
				if(partial_content_length == -1)
					continue;

				output.write(buffer, read_length, partial_content_length);
				output.flush();

				read_length += partial_content_length;
				System.out.println((int)(read_length * 100 / content_length) + "% : " + jget_info.getURL());

				// W[
				jget_info.setCurrentPosition(read_length);
				jget_info_list.put(jget_info.getURL(), jget_info);
				saveInfoList();

				yield();
			}
			System.out.println("Finished : " + jget_info.getURL());

			// Rec擾ɁAW[폜
			jget_info_list.remove(jget_info.getURL());
			saveInfoList();

			output.close();
		}
		catch(IOException io_ex)
		{
			io_ex.printStackTrace();
			throw new CannotGetError("IO_Exception");
		}
	}

	/**
		JGet̎擾󋵃Xg(jget_info_list)AfBXN(jget_info.lst)ɏo
	*/
	private synchronized void saveInfoList()
	{
		try
		{
			ObjectOutputStream object_out = new ObjectOutputStream(new FileOutputStream(info_list_file));
			object_out.writeObject(jget_info_list);
			object_out.close();
		}
		catch(IOException io_ex)
		{
			io_ex.printStackTrace();
			throw new CannotGetError("Log File Error by Writing");
		}
	}

	/**
		JGet̎擾󋵃Xg(jget_info_list)AfBXN(jget_info.lst)ǂݏo
		@return	擾󋵃Xg
	*/
	private synchronized Hashtable loadInfoList()
	{
		try
		{
			ObjectInputStream object_in = new ObjectInputStream(new FileInputStream(info_list_file));
			jget_info_list = (Hashtable)object_in.readObject();
			object_in.close();

			return(jget_info_list);
		}
		catch(ClassNotFoundException cnf_ex)
		{
			cnf_ex.printStackTrace();
		}
		catch(IOException io_ex)
		{
			io_ex.printStackTrace();
		}
		throw new CannotGetError("Log File Error by Reading");
	}
}